python錯誤處理詳解

NO IMAGE

在程式執行的過程中,如果發生了錯誤,可以事先約定返回一個錯誤程式碼,這樣,就可以知道是否有錯,以及出錯的原因。在作業系統提供的呼叫中,返回錯誤碼非常常見。比如開啟檔案的函式open(),成功時返回檔案描述符(就是一個整數),出錯時返回-1。

用錯誤碼來表示是否出錯十分不便,因為函式本身應該返回的正常結果和錯誤碼混在一起,造成呼叫者必須用大量的程式碼來判斷是否出錯:
複製程式碼 程式碼如下:
def foo():
    r = some_function()
    if r==(-1):
        return (-1)
    # do something
    return r

def bar():
    r = foo()
    if r==(-1):
        print ‘Error’
    else:
        pass

一旦出錯,還要一級一級上報,直到某個函式可以處理該錯誤(比如,給使用者輸出一個錯誤資訊)。

所以高階語言通常都內建了一套try…except…finally…的錯誤處理機制,Python也不例外。

try

讓我們用一個例子來看看try的機制:
複製程式碼 程式碼如下:
try:
    print ‘try…’
    r = 10 / 0
    print ‘result:’, r
except ZeroDivisionError, e:
    print ‘except:’, e
finally:
    print ‘finally…’
print ‘END’

當我們認為某些程式碼可能會出錯時,就可以用try來執行這段程式碼,如果執行出錯,則後續程式碼不會繼續執行,而是直接跳轉至錯誤處理程式碼,即except語句塊,執行完except後,如果有finally語句塊,則執行finally語句塊,至此,執行完畢。

上面的程式碼在計算10 / 0時會產生一個除法運算錯誤:
複製程式碼 程式碼如下:
try…
except: integer division or modulo by zero
finally…
END

從輸出可以看到,當錯誤發生時,後續語句print ‘result:’, r不會被執行,except由於捕獲到ZeroDivisionError,因此被執行。最後,finally語句被執行。然後,程式繼續按照流程往下走。

如果把除數0改成2,則執行結果如下:
複製程式碼 程式碼如下:
try…
result: 5
finally…
END

由於沒有錯誤發生,所以except語句塊不會被執行,但是finally如果有,則一定會被執行(可以沒有finally語句)。

你還可以猜測,錯誤應該有很多種類,如果發生了不同型別的錯誤,應該由不同的except語句塊處理。沒錯,可以有多個except來捕獲不同型別的錯誤:
複製程式碼 程式碼如下:
try:
    print ‘try…’
    r = 10 / int(‘a’)
    print ‘result:’, r
except ValueError, e:
    print ‘ValueError:’, e
except ZeroDivisionError, e:
    print ‘ZeroDivisionError:’, e
finally:
    print ‘finally…’
print ‘END’

int()函式可能會丟擲ValueError,所以我們用一個except捕獲ValueError,用另一個except捕獲ZeroDivisionError。

此外,如果沒有錯誤發生,可以在except語句塊後面加一個else,當沒有錯誤發生時,會自動執行else語句:
複製程式碼 程式碼如下:
try:
    print ‘try…’
    r = 10 / int(‘a’)
    print ‘result:’, r
except ValueError, e:
    print ‘ValueError:’, e
except ZeroDivisionError, e:
    print ‘ZeroDivisionError:’, e
else:
    print ‘no error!’
finally:
    print ‘finally…’
print ‘END’

Python的錯誤其實也是class,所有的錯誤型別都繼承自BaseException,所以在使用except時需要注意的是,它不但捕獲該型別的錯誤,還把其子類也“一網打盡”。比如:
複製程式碼 程式碼如下:
try:
    foo()
except StandardError, e:
    print ‘StandardError’
except ValueError, e:
    print ‘ValueError’

第二個except永遠也捕獲不到ValueError,因為ValueError是StandardError的子類,如果有,也被第一個except給捕獲了。

Python所有的錯誤都是從BaseException類派生的,常見的錯誤型別和繼承關係看這裡:
https://docs.python.org/2/library/exceptions.html#exception-hierarchy

使用try…except捕獲錯誤還有一個巨大的好處,就是可以跨越多層呼叫,比如函式main()呼叫foo(),foo()呼叫bar(),結果bar()出錯了,這時,只要main()捕獲到了,就可以處理:
複製程式碼 程式碼如下:
def foo(s):
    return 10 / int(s)

def bar(s):
    return foo(s) * 2

def main():
    try:
        bar(‘0’)
    except StandardError, e:
        print ‘Error!’
    finally:
        print ‘finally…’

也就是說,不需要在每個可能出錯的地方去捕獲錯誤,只要在合適的層次去捕獲錯誤就可以了。這樣一來,就大大減少了寫try…except…finally的麻煩。

呼叫堆疊

如果錯誤沒有被捕獲,它就會一直往上拋,最後被Python直譯器捕獲,列印一個錯誤資訊,然後程式退出。來看看err.py:
複製程式碼 程式碼如下:
# err.py:
def foo(s):
    return 10 / int(s)

def bar(s):
    return foo(s) * 2

def main():
    bar(‘0’)

main()

執行,結果如下:
複製程式碼 程式碼如下:
$ python err.py
Traceback (most recent call last):
  File “err.py”, line 11, in <module>
    main()
  File “err.py”, line 9, in main
    bar(‘0’)
  File “err.py”, line 6, in bar
    return foo(s) * 2
  File “err.py”, line 3, in foo
    return 10 / int(s)
ZeroDivisionError: integer division or modulo by zero

出錯並不可怕,可怕的是不知道哪裡出錯了。解讀錯誤資訊是定位錯誤的關鍵。我們從上往下可以看到整個錯誤的呼叫函式鏈:

錯誤資訊第1行:
複製程式碼 程式碼如下:
Traceback (most recent call last):

告訴我們這是錯誤的跟蹤資訊。

第2行:
複製程式碼 程式碼如下:
  File “err.py”, line 11, in <module>
    main()

呼叫main()出錯了,在程式碼檔案err.py的第11行程式碼,但原因是第9行:
複製程式碼 程式碼如下:
  File “err.py”, line 9, in main
    bar(‘0’)

呼叫bar(‘0’)出錯了,在程式碼檔案err.py的第9行程式碼,但原因是第6行:
複製程式碼 程式碼如下:
  File “err.py”, line 6, in bar
    return foo(s) * 2

原因是return foo(s) * 2這個語句出錯了,但這還不是最終原因,繼續往下看:
複製程式碼 程式碼如下:
  File “err.py”, line 3, in foo
    return 10 / int(s)

原因是return 10 / int(s)這個語句出錯了,這是錯誤產生的源頭,因為下面列印了:
複製程式碼 程式碼如下:
ZeroDivisionError: integer division or modulo by zero

根據錯誤型別ZeroDivisionError,我們判斷,int(s)本身並沒有出錯,但是int(s)返回0,在計算10 / 0時出錯,至此,找到錯誤源頭。

記錄錯誤

如果不捕獲錯誤,自然可以讓Python直譯器來列印出錯誤堆疊,但程式也被結束了。既然我們能捕獲錯誤,就可以把錯誤堆疊列印出來,然後分析錯誤原因,同時,讓程式繼續執行下去。

Python內建的logging模組可以非常容易地記錄錯誤資訊:
複製程式碼 程式碼如下:
# err.py
import logging

def foo(s):
    return 10 / int(s)

def bar(s):
    return foo(s) * 2

def main():
    try:
        bar(‘0’)
    except StandardError, e:
        logging.exception(e)

main()
print ‘END’

同樣是出錯,但程式列印完錯誤資訊後會繼續執行,並正常退出:
複製程式碼 程式碼如下:
$ python err.py
ERROR:root:integer division or modulo by zero
Traceback (most recent call last):
  File “err.py”, line 12, in main
    bar(‘0’)
  File “err.py”, line 8, in bar
    return foo(s) * 2
  File “err.py”, line 5, in foo
    return 10 / int(s)
ZeroDivisionError: integer division or modulo by zero
END

通過配置,logging還可以把錯誤記錄到日誌檔案裡,方便事後排查。

丟擲錯誤

因為錯誤是class,捕獲一個錯誤就是捕獲到該class的一個例項。因此,錯誤並不是憑空產生的,而是有意建立並丟擲的。Python的內建函式會丟擲很多型別的錯誤,我們自己編寫的函式也可以丟擲錯誤。

如果要丟擲錯誤,首先根據需要,可以定義一個錯誤的class,選擇好繼承關係,然後,用raise語句丟擲一個錯誤的例項:
複製程式碼 程式碼如下:
# err.py
class FooError(StandardError):
    pass

def foo(s):
    n = int(s)
    if n==0:
        raise FooError(‘invalid value: %s’ % s)
    return 10 / n

執行,可以最後跟蹤到我們自己定義的錯誤:
複製程式碼 程式碼如下:
$ python err.py
Traceback (most recent call last):
  …
__main__.FooError: invalid value: 0

只有在必要的時候才定義我們自己的錯誤型別。如果可以選擇Python已有的內建的錯誤型別(比如ValueError,TypeError),儘量使用Python內建的錯誤型別。

最後,我們來看另一種錯誤處理的方式:
複製程式碼 程式碼如下:
# err.py
def foo(s):
    n = int(s)
    return 10 / n

def bar(s):
    try:
        return foo(s) * 2
    except StandardError, e:
        print ‘Error!’
        raise

def main():
    bar(‘0’)

main()

在bar()函式中,我們明明已經捕獲了錯誤,但是,列印一個Error!後,又把錯誤通過raise語句丟擲去了,這不有病麼?

其實這種錯誤處理方式不但沒病,而且相當常見。捕獲錯誤目的只是記錄一下,便於後續追蹤。但是,由於當前函式不知道應該怎麼處理該錯誤,所以,最恰當的方式是繼續往上拋,讓頂層呼叫者去處理。

raise語句如果不帶引數,就會把當前錯誤原樣丟擲。此外,在except中raise一個Error,還可以把一種型別的錯誤轉化成另一種型別:
複製程式碼 程式碼如下:
try:
    10 / 0
except ZeroDivisionError:
    raise ValueError(‘input error!’)

只要是合理的轉換邏輯就可以,但是,決不應該把一個IOError轉換成毫不相干的ValueError。

小結

Python內建的try…except…finally用來處理錯誤十分方便。出錯時,會分析錯誤資訊並定位錯誤發生的程式碼位置才是最關鍵的。

程式也可以主動丟擲錯誤,讓呼叫者來處理相應的錯誤。但是,應該在文件中寫清楚可能會丟擲哪些錯誤,以及錯誤產生的原因。

您可能感興趣的文章:

深入理解python try異常處理機制簡單介紹Python中的try和finally和with方法Python 錯誤和異常小結Python程式設計師開發中常犯的10個錯誤python新手經常遇到的17個錯誤分析python中的錯誤處理python實現帶錯誤處理功能的遠端檔案讀取方法python使用socket遠端連線錯誤處理方法Python異常處理總結python中的五種異常處理機制介紹Python中的錯誤和異常處理簡單操作示例【try-except用法】